"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = mockProvider;

var _mocks = _interopRequireDefault(require("./mocks"));

var _on2 = _interopRequireDefault(require("./on"));

var _send2 = _interopRequireDefault(require("./send"));

var _state = _interopRequireDefault(require("./state"));

var _subscribe2 = _interopRequireDefault(require("./subscribe"));

var _unsubscribe2 = _interopRequireDefault(require("./unsubscribe"));

// Copyright 2017-2018 @polkadot/api-provider authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.

/**
 * A moock provider mainly used for testing.
 * @return {ProviderInterface} The mock provider
 */
function mockProvider() {
  const self = (0, _state.default)();
  (0, _mocks.default)(self);
  return {
    isConnected: () => true,
    on: (type, sub) => (0, _on2.default)(self, type, sub),
    send: (method, params) => (0, _send2.default)(self, method, params),
    subscribe: (type, method, ...params) => (0, _subscribe2.default)(self, type, method, params),
    unsubscribe: (type, method, id) => (0, _unsubscribe2.default)(self, type, method, id)
  };
}